REM git clone https://github.com/libkml/libkml

set ARCH=%1

set P=libkml-vc14
set V=2.2
set B=1

set CMAKEGEN=NMake Makefiles

if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set VCARCH=x86
	REM set CMAKEGEN=Visual Studio 14 2015
	set ZLIB_LIBRARY=C:\OSGEO4W\lib\zlib.lib
) else if "%ARCH%"=="x86_64" (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set VCARCH=x64
	REM set CMAKEGEN=Visual Studio 14 2015 amd64
	set ZLIB_LIBRARY=C:\OSGEO4W64\lib\zdll.lib
) else (
	echo unexpected arch & goto error
)

if "%OSGEO4W_REP%"=="" (
	echo repository not set & goto error
)

set R=..\..\..\%ARCH%\release\%P%

call %OSGEO4W_ROOT%\bin\o4w_env.bat

call "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
echo on
path C:\Program Files\CMake\bin;C:\Program Files (x86)\Microsoft Visual Studio 14.0\Common7\IDE;c:\cygwin\bin;%PATH%

set EP_BASE=%CD%\external-%ARCH%

if not exist build-%ARCH% mkdir build-%ARCH%
if not exist install-%ARCH% mkdir install-%ARCH%
if not exist %EP_BASE% mkdir %EP_BASE%
if not exist %R% mkdir %R%

if not exist 0001-osgeo4w-adjustments.patch.applied (
	cd ..
	git apply osgeo4w\0001-osgeo4w-adjustments.patch >osgeo4w\0001-osgeo4w-adjustments.patch.applied
	cd osgeo4w
)

cd build-%ARCH%

cmake -G "%CMAKEGEN%" ^
 	-D CMAKE_BUILD_TYPE=Release ^
	-D BUILD_SHARED_LIBS=OFF ^
	-D CMAKE_CONFIGURATION_TYPES=Release ^
 	-D EXPAT_INCLUDE_DIR=%OSGEO4W_ROOT:\=/%/include ^
 	-D EXPAT_LIBRARY=%OSGEO4W_ROOT:\=/%/lib/libexpat.lib ^
 	-D Boost_INCLUDE_DIR=%OSGEO4W_ROOT:\=/%/include/boost-1_56 ^
 	-D Boost_LIBRARY_DIR=%OSGEO4W_ROOT:\=/%/lib ^
	-D ZLIB_LIBRARY=%ZLIB_LIBRARY:\=/% ^
 	-D CMAKE_INSTALL_PREFIX="../install-%ARCH%/libs/vc14" ^
  	-D BIN_INSTALL_DIR="../install-%ARCH%/bin" ^
	..\..

cd ..

cmake --build build-%ARCH% --target clean --config Release
if errorlevel 1 (echo build error & goto error)

cmake --build build-%ARCH% --config Release
if errorlevel 1 (echo build error & goto error)

cmake --build build-%ARCH% --target INSTALL --config Release
if errorlevel 1 (echo install error & goto error)

copy external-%ARCH%\Install\MiniZip\lib\minizip.lib install-%ARCH%\libs\vc14\lib
copy external-%ARCH%\Install\UriParser\lib\uriparser.lib install-%ARCH%\libs\vc14\lib

tar -C .. -cvjf %R:\=/%/%P%-%V%-%B%-src.tar.bz2 osgeo4w/package.cmd osgeo4w/setup.hint osgeo4w/0001-osgeo4w-adjustments.patch
if errorlevel 1 (echo src error & goto error)

tar -C install-%ARCH% -cvjf %R:\=/%/%P%-%V%-%B%.tar.bz2 libs
if errorlevel 1 (echo package error & goto error)

exit

:error
exit
